#include <stdio.h>

#define FNAMLEN 400

/* all times in milliseconds */

#define SLEEPLEN 50U /* sleep that long between two attempts to read or
        write a character */

#define TIMEOUT_WAITACK 300U /* Timeout for ack or nack response to an ENQ */
#define TIMEOUT_WAITDATA 2000U /* Timeout reading a data byte */
#define TIMEOUT_ENDDATA 4000U /* Timeout for ACK/NACK after Data */
#define TIMEOUT_EOT 4300U /* Timeout before last EOT */

#define PREF_FLASH 0xd000U /* preference field: flash */

#define STX 0x02
#define ETX 0x03
#define EOT 0x04
#define ENQ 0x05
#define ACK 0x06
#define NACK 0x15
#define ETB 0x17

#define MASTERDEBUG 0

#define DEBUG if (debug) fprintf
#define PROTOSNOOP if (protosnoop) commchar_log
#define SENDSNOOP if (sendsnoop) commchar_log

typedef unsigned char uchar;

void commchar_log(FILE * file, char dir, uchar c);
int parse_numbers(char *incoming, int max, char *array);
void camungetc(uchar c);
int camgetc(int cam, int timeout);
int camputc(int cam, uchar ch);
uchar *get_datablock(int cam, int *len, int *etbetx,
                     int retry, int init_timeout);
int camreaddata(int cam, FILE * ausf);
int send_escaped(int cam, uchar c);
int camsenddata(int cam, uchar * data, int len);
int ping(int cam, int retries);
int raise_dtr(int cam);
int drop_dtr(int cam);
void cam_err(int errcode);
int cam_open(char *devnam, int bps);
int cam_close(int cam);
int cancel(int cam);
int send_command(int cam, uchar * datablock, int len,
                 int init_timeout, uchar ** infoblock,
                 int getsecondblock);
void getinfo(int cam);
int setpref(int cam, unsigned int preffield, unsigned int prefvalue);
int getimageinfo(int imgno, int cam, uchar ** resblock);
int set_tod(int cam);
int get_status(int cam);
void decode_str(char *buf, int start, int end, uchar * block);
void cleanup(int signo);
void usage(char *progname,char *proghelp,char *moreopts);
